// =================================================================================
//
//	CBaseBindStatusCallback.h		1996 Microsoft Corporation All rights reserved.
//
// =================================================================================

#ifndef _H_CBaseBindStatusCallback
#define _H_CBaseBindStatusCallback
#pragma once


class CBaseBindStatusCallback:
	public CBaseCOM,
	public IBindStatusCallback
{
public:
	//  *** CBaseBindStatusCallback methods ***
	CBaseBindStatusCallback(void);
	virtual ~CBaseBindStatusCallback(void);

	//  *** IUnknown methods ***
	STDMETHOD (QueryInterface)(REFIID inRefID, void** outObj);
	STDMETHOD_ (Uint32, AddRef)(void) { return CBaseCOM::AddRef(); }
	STDMETHOD_ (Uint32, Release)(void) { return CBaseCOM::Release(); }

	//  *** IBindStatusCallback methods ***
	STDMETHOD (OnStartBinding)(Uint32 BSCOption, IBinding* Binding);
	STDMETHOD (GetPriority)(Int32* Priority);
	STDMETHOD (OnLowResource)(Uint32 reserved);
	STDMETHOD (OnProgress)(Uint32 Progress, Uint32 ProgressMax, Uint32 StatusCode, const Char8* StatusText);
	STDMETHOD (OnStopBinding)(ErrorCode Result, const char* Error);
	STDMETHOD (GetBindInfo)(Uint32* BINDF, BINDINFO* BindInfo);
	STDMETHOD (OnDataAvailable)(Uint32 BSCF, Uint32 Size, FORMATETC* FormatEtc, STGMEDIUM* StgMedium);
	STDMETHOD (OnObjectAvailable)(REFIID RefID, IUnknown* Unknown);

protected:
	//  *** CBaseBindStatusCallback methods ***
	ErrorCode			OpenStream(IContainerSite* inContainerSiteP, LPOLESTR URLString, Boolean BindFile);

	//  *** CBaseBindStatusCallback member variables ***
	Uint32				mDataSize;	
	Uint32				mTotalStreamLen;

    IBinding* 			mibP;
};
#endif