// =================================================================================
//
//	CEventClient.h				1996 Microsoft Corporation All rights reserved.
//
// =================================================================================

#ifndef _H_CEventClient
#define _H_CEventClient
#pragma once

#include "CBaseControl.h"

class CEventClient :  
	public CBaseControl,
	public IStandardEvents
{
public:
    //  *** CEventClient methods ***
    CEventClient(void);
    virtual ~CEventClient(void);

    //  *** IUnknown methods ***
    STDMETHOD (QueryInterface)(REFIID inRefID, void** outObj);
    STDMETHOD_(Uint32,AddRef)(THIS) {return CBaseControl::AddRef();}
    STDMETHOD_(Uint32,Release)(THIS) {return CBaseControl::Release();}
    
    // *** IObjectWithSite methods ***
    STDMETHOD (SetSite)(THIS_ IUnknown* inUnkSite);

    // *** IControl methods ***
    STDMETHOD (Draw) (THIS_ DrawContext* inContext);
	STDMETHOD (DoIdle)(THIS_ Uint32 inIdleRefCon);

	// **** IStandardEvents methods
    STDMETHOD (OnDoubleClick)(THIS_ IUnknown* inSource, PlatformEvent* inEvent);
    STDMETHOD (OnKeyDown)(THIS_ IUnknown* inSource, PlatformEvent* inEvent);
    STDMETHOD (OnAutoKey)(THIS_ IUnknown* inSource, PlatformEvent* inEvent);
    STDMETHOD (OnKeyUp)(THIS_ IUnknown* inSource, PlatformEvent* inEvent);
    STDMETHOD (OnMouseDown)(THIS_ IUnknown* inSource, PlatformEvent* inEvent);
    STDMETHOD (OnMouseUp)(THIS_ IUnknown* inSource, PlatformEvent* inEvent);
    

private:
	Str255** 		mMessage;
	Int16			mNumMsgs;
	Int16			mCurrentMsg;
	Uint32			mCookie;

    void	FinishEvent(void);
	void	AddMessage(Str255 inMessage);
	void	InitMessages(void);  
};

#endif
