#include "ocheaders.h"
#include "CBaseControl.h"
#include "CErrorControl.h"
#include "CLabelControl.h"
#include "CError.h"
#include "CLabelError.h"
#include "FnAssert.h"

#define MControl ((CLabelControl *)mControl)

///////////////////////////////////////////////////////////////////////////////
//
// CLabelError::CLabelError
//

CLabelError::CLabelError(ErrorCode error) : CError(error)
{
}

CLabelError::CLabelError(ErrorCode error, CErrorControl * control)
	: CError(error, control)
{
}

///////////////////////////////////////////////////////////////////////////////
//
// CLabelError::HandleError
//

void CLabelError::HandleError(void)
{
	switch ( mErrorCode )
	{
		case CONTROL_GWORLD_ALLOCATION_ERROR:
		{
			ASSERT(0, "A GWorld could not be allocated!");			
			break;
		}
		case GWORLD_ALLOCATION_ERROR:
		{
			ASSERT(0, "A GWorld could not be allocated!");
			break;
		}
		
		case ROTATION_FAILED_ERROR:
		{
			ASSERT(0, "Unable to perform rotation!");
			break;
		}
		
		case CONTROL_BAD_ALIGNMENT_PARAM_ERROR:
		{
			ASSERT(0, "Bogus parameter passed in");
			break;
		}
		default:
			break;
	}
}
