// =================================================================================
//
//	CListBoxControl.h				1996 Microsoft Corporation All rights reserved.
//
// =================================================================================

#ifndef _H_CListBoxControl
#define _H_CListBoxControl
#pragma once

#include "CBaseControl.h"
#include "CBaseBindStatusCallback.h"

typedef struct
{
	Str255	Data;
	Boolean	Inserted;
}
listitemdata;


class CListBoxControl :
		public CBaseControl,
		public CBaseBindStatusCallback
{

public:
	// *** CListBoxControl methods ***
	CListBoxControl(void);
	~CListBoxControl(void);

	// *** IUnknown methods ***
	STDMETHOD (QueryInterface)(REFIID inRefID, void** outObj);

	// *** IControl methods ***
	STDMETHOD (Draw) (THIS_ DrawContext* inContext);
	STDMETHOD (SetFocus)(THIS_ FocusCommand inCommand, FocusSet inFocus);
	STDMETHOD (DoMouse)(THIS_ MouseEventType inMouseET, PlatformEvent* inEvent) ;
	STDMETHOD (DoKey)(THIS_ KeyEventType inKeyET, Char8 inChar, PlatformEvent* inEvent) ;
	STDMETHOD (DoIdle)(THIS_ Uint32 inIdleRefCon) ;

	//  *** IPersistPropertyBag methods ***
	STDMETHOD (Load)(IPropertyBag* PropBag, IErrorLog* ErrorLog);
	STDMETHOD (LoadTextState)(IPropertyBag *PropertyBag,IErrorLog* ErrorLog);

	//  *** IBindStatusCallback methods ***
	STDMETHOD (OnStopBinding)(ErrorCode Result, const Char8* Error);
	STDMETHOD (OnDataAvailable)(Uint32 BSCF, Uint32 Size, FORMATETC* FormatEtc, STGMEDIUM* StgMedium);


private:
	// *** private methods ***
	void		DrawList(GrafPtr pGrafDraw, Rect* lprect);

	// *** private members ***
	LPBINDHOST		mBindSiteP;
	Uchar8			mDataURL[MAX_URL_STRING];
	ListHandle		mListH;
	listitemdata**	mData;
	Int16			mItemCount;
	Int16			mItemInProgressIndex;
	listitemdata	mItemInProgress;
	FocusSet		mOwnedFoci;
	Boolean			mChanged;
	Boolean			mLoaded;
	Point			mSelectedCell;
};

#endif
