// ---------------------------------------------------------------------------
// CDirectoryTable.h
// written by Rick Eames
// (c) 1996 Rick Eames.  All Rights Reserved.
//
// ---------------------------------------------------------------------------

#pragma once

#include 	<LHierarchyTable.h>
#include	<LDragAndDrop.h>
#include	<LBroadcaster.h>



class CDirectoryTable : public LHierarchyTable,
						public LBroadcaster
{

public:
		enum { class_ID = 'dTAB'};
		
		static CDirectoryTable* CreateFromStream(LStream *inStream);
		
								CDirectoryTable(LStream *inStream);
		virtual					~CDirectoryTable() { }
		virtual void			AddFile(FSSpec &inFile, Int32, Int32, Int32);
		virtual void			AddFolder(FSSpec &inFile, Int32, Int32, Int32);
		virtual void			BuildList(FSSpec	&inTopDirectory, Int32);
		virtual Int32			GetDirectoryID(FSSpec &inDirectory);
		virtual void			DrawCell(const STableCell	&inCell, const Rect			&inLocalRect);
		
		virtual void			ClickCell(const STableCell& inCell,const SMouseDownEvent&	inMouseDown);
		virtual void			HiliteCellActively(const STableCell	&inCell, Boolean inHilite);
		virtual void			HiliteCellInactively(const STableCell	&inCell, Boolean inHilite);
		virtual void			HiliteSelection(Boolean, Boolean);
		
protected:

private:

		FSSpec		*mDirectory;
		Int32		mCurrentRow;
		STableCell	mLastDragCell;
};