/*
	CFixedScroller.cp
	
	This is a quick hack to fix a problem with PowerPlant in the
	LGrafPortView.  Basically, we have to force the scrolled view
	to draw or nothing happens.
	
*/

#include "CFixedScroller.h"
#include <LStdControl.h>

CFixedScroller*
CFixedScroller::CreateFromStream(
	LStream		*inStream)
{
	return (new CFixedScroller(inStream));
}

CFixedScroller::CFixedScroller(
	LStream		*inStream)
		: LScroller(inStream)
{
}

void
CFixedScroller::VertScroll(
	const Int16	inPart)
{
	LScroller::VertScroll(inPart);
	mScrollingView->Draw(nil);		// <--- this is the new call
	mVerticalBar->FocusDraw();		// <--- Macintosh hates us if we don't do this
}

void
CFixedScroller::HorizScroll(
	const Int16 inPart)
{
	LScroller::HorizScroll(inPart);
	mScrollingView->Draw(nil);		// <--- ditto
	mHorizontalBar->FocusDraw();	// <--- ditto
}